﻿/*
	DbFS.NET
    Copyright (C) 2016 SCAND Ltd, svg@scand.com

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

namespace dbfs.repository
{
	using System.Linq;
	using dbfs.exceptions;
	using dbfs.model;

	class UserManagement : RepositoryManagement
	{
		public User TryGet(int id)
		{
			return _context.Users.FirstOrDefault(e => e.id == id);
		}

		/// <exception cref="UserDoesNotExistException"></exception>
		public User Get(int id)
		{
			var user = TryGet(id);

			if (user == null)
				throw new UserDoesNotExistException(id);

			return user;
		}

		public User TryGet(string name)
		{
			return _context.Users.FirstOrDefault(e => e.UserName == name);
		}

		/// <exception cref="UserDoesNotExistException"></exception>
		public User Get(string name)
		{
			var user = TryGet(name);

			if (user == null)
				throw new UserDoesNotExistException(name);

			return user;
		}
	}
}
